"""The product type for Pop VLAN."""

from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from gso.products.product_blocks.pop_vlan import PopVlanBlock, PopVlanBlockInactive, PopVlanBlockProvisioning


class PopVlanInactive(SubscriptionModel, is_base=True):
    """A Pop VLAN that is inactive."""

    pop_vlan: PopVlanBlockInactive


class PopVlanProvisioning(PopVlanInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    """A Pop VLAN that is being provisioned."""

    pop_vlan: PopVlanBlockProvisioning


class PopVlan(PopVlanProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    """A Pop VLAN that is active."""

    pop_vlan: PopVlanBlock
